unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtDlgs, StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    SavePictureDialog1: TSavePictureDialog;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Image2: TImage;
    BitBtn3: TBitBtn;
    SpeedButton1: TSpeedButton;
    procedure BitBtn1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    procedure WMWINDOWPOSCHANGING(var Msg: TWMWINDOWPOSCHANGING); message WM_WINDOWPOSCHANGING;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Window: HWND;
  SaveDir: string = '';
  SaveNum: Integer = 1;

implementation

{$R *.dfm}

procedure TForm1.BitBtn1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Windows.SetFocus(BitBtn1.Handle);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  P: TPoint;
  Buff: array [0..127] of Char;
begin
  GetCursorPos(P);
  Window := WindowFromPoint(P);
  SendMessage(Window, WM_GETTEXT, 127, Integer(@Buff));
  Caption := 'Grab from: ' + StrPas(Buff) + ' Wnd: ' + IntToStr(Window);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
var
  w, h: Integer;
  R: TRect;
  FileName: string;
  i: Integer;
begin
  GetWindowRect(Window, R);
  w := R.Right - R.Left;
  h := R.Bottom - R.Top;
  Image2.Width := w;
  Image2.Height := h;
  BitBlt(Image2.Canvas.Handle, 0, 0, w, h, GetDC(Window), 0, 0, SRCCOPY);
  if w/h > 369/209 then
    begin
      Image1.Width := 369;
      Image1.Height := Round(Image1.Width * h / w);
    end
  else
    begin
      Image1.Height := 209;
      Image1.Width := Round(Image1.Height * w / h);
    end;
//  Image1.Stretch := true;
  Image1.Picture.Assign(Image2.Picture);
  Image1.Left := (ClientWidth - Image1.Width) div 2;
  Image1.Top := (209 - Image1.Height) div 2;
  if CheckBox1.Checked then
    begin
      if SaveDir = '' then
        if SavePictureDialog1.Execute then SaveDir := ExtractFileDir(SavePictureDialog1.FileName);
      while FileExists(SaveDir + '\' + IntToStr(SaveNum) + '.bmp') do SaveNum := SaveNum + 1;
      FileName := SaveDir + '\' + IntToStr(SaveNum) + '.bmp';
      Image2.Picture.SaveToFile(FileName);
    end;
end;

procedure TForm1.FormShow(Sender: TObject);
var
  H: HWND;
  R: TRect;
begin
  H := FindWindow(PChar('Shell_TrayWnd'), nil);
  GetWindowRect(H, R);
  Left := Screen.Width - Width;
  Top := Screen.Height - Height - R.Bottom + R.Top;
end;

procedure TForm1.WMWINDOWPOSCHANGING(var Msg: TWMWINDOWPOSCHANGING);
var
  rWorkArea: TRect;
  StickAt: Word;
  Docked: Boolean;
begin
  StickAt := 20;
  Docked := false;
  
  SystemParametersInfo(SPI_GETWORKAREA, 0, @rWorkArea, 0);

  with Msg.WindowPos^ do
    begin
      if x <= rWorkArea.Left + StickAt then
        begin
          x := rWorkArea.Left;
          Docked := TRUE;
        end;

      if x + cx >= rWorkArea.Right - StickAt then
        begin
          x := rWorkArea.Right - cx;
          Docked := TRUE;
        end;

      if y <= rWorkArea.Top + StickAt then
        begin
          y := rWorkArea.Top;
          Docked := TRUE;
        end;

      if y + cy >= rWorkArea.Bottom - StickAt then
        begin
          y := rWorkArea.Bottom - cy;
          Docked := TRUE;
        end;

     if Docked then
       begin
         with rWorkArea do
           begin
             //      
             if x < Left then x := Left;
             if x + cx > Right then x := Right - cx;
             if y < Top then y := Top;
             if y + cy > Bottom then y := Bottom - cy;
           end; { rWorkArea}
       end; {}
    end; { Msg.WindowPos^}

  inherited;
end;
procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  if SavePictureDialog1.Execute then
    Image2.Picture.SaveToFile(SavePictureDialog1.FileName);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  Buff: array [0..127] of Char;
begin
  Window := GetParent(Window);
  SendMessage(Window, WM_GETTEXT, 127, Integer(@Buff));
  Caption := 'Grab from: ' + StrPas(Buff) + ' Wnd: ' + IntToStr(Window);
end;

end.
